#region Using declarations
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Input;
using System.Windows.Media;
using System.Xml.Serialization;
using NinjaTrader.Cbi;
using NinjaTrader.Gui;
using NinjaTrader.Gui.Chart;
using NinjaTrader.Gui.SuperDom;
using NinjaTrader.Gui.Tools;
using NinjaTrader.Data;
using NinjaTrader.NinjaScript;
using NinjaTrader.Core.FloatingPoint;
using NinjaTrader.NinjaScript.DrawingTools;
using MZpack;
using MZpack.NT8;

#endregion

//This namespace holds Indicators in this folder and is required. Do not change it. 
namespace NinjaTrader.NinjaScript.Indicators
{
	public class VolumeProfileTest : Indicator
	{
		IVolumeProfileIndicator indicator;
		IVolumeProfile __p;
		
		protected override void OnStateChange()
		{
			if (State == State.SetDefaults)
			{
				Description									= @"Enter the description for your new custom Indicator here.";
				Name										= "VolumeProfileTest";
				Calculate									= Calculate.OnEachTick;
				IsOverlay									= true;
				DisplayInDataBox							= true;
				DrawOnPricePanel							= true;
				DrawHorizontalGridLines						= true;
				DrawVerticalGridLines						= true;
				PaintPriceMarkers							= true;
				ScaleJustification							= NinjaTrader.Gui.Chart.ScaleJustification.Right;
				//Disable this property if your indicator requires custom values that cumulate with each new market data event. 
				//See Help Guide for additional information.
				IsSuspendedWhileInactive					= true;
			}
			else if (State == State.Configure)
			{
				ClearOutputWindow();
				
				indicator = VP();
				indicator.ProfileCreation = ProfileCreation.Bar;
				indicator.IncrementalRefresh = true;
			}
			else if (State == State.Transition)
			{
				Print("State.Transition");
				
				if (indicator.Profiles.Count() > 0)
				{
					Print("Bar profiles count "+indicator.Profiles.Count());
					IVolumeProfile p = indicator.Profiles.ElementAt(indicator.Profiles.Count()-1);
					Print(string.Format("Current bar profile. Total volume: {0}, Buy: {1}, Sell: {2}",p.Volume, p.BuyVolume, p.SellVolume));
				
					indicator.ProfileCreation = ProfileCreation.Custom;
					indicator.RefreshModel();
					__p = indicator.AddProfile();
					__p.AssignRange(p.BeginBarIdx - 10, p.EndBarIdx);
					__p.IsDeveloping = true;
					__p.Calc();
					Print(string.Format("Custom profile. Total volume: {0}, Buy: {1}, Sell: {2}, POC: {3}, POC vol: {4}, Delta {5}",
						__p.Volume, __p.BuyVolume, __p.SellVolume, __p.POC, __p.POCVolume, __p.Delta));
				}
			}
		}

		protected override void OnMarketData(MarketDataEventArgs e)
		{
			if (State == State.Realtime && __p != null)			
			{
					Print(string.Format("Developing profile. Total volume: {0}, Buy: {1}, Sell: {2}, POC: {3}, POC vol: {4}, Delta {5}",
						__p.Volume, __p.BuyVolume, __p.SellVolume, __p.POC, __p.POCVolume, __p.Delta));
			}
		}
		
		protected override void OnBarUpdate()
		{
		}
	}
}

#region NinjaScript generated code. Neither change nor remove.

namespace NinjaTrader.NinjaScript.Indicators
{
	public partial class Indicator : NinjaTrader.Gui.NinjaScript.IndicatorRenderBase
	{
		private VolumeProfileTest[] cacheVolumeProfileTest;
		public VolumeProfileTest VolumeProfileTest()
		{
			return VolumeProfileTest(Input);
		}

		public VolumeProfileTest VolumeProfileTest(ISeries<double> input)
		{
			if (cacheVolumeProfileTest != null)
				for (int idx = 0; idx < cacheVolumeProfileTest.Length; idx++)
					if (cacheVolumeProfileTest[idx] != null &&  cacheVolumeProfileTest[idx].EqualsInput(input))
						return cacheVolumeProfileTest[idx];
			return CacheIndicator<VolumeProfileTest>(new VolumeProfileTest(), input, ref cacheVolumeProfileTest);
		}
	}
}

namespace NinjaTrader.NinjaScript.MarketAnalyzerColumns
{
	public partial class MarketAnalyzerColumn : MarketAnalyzerColumnBase
	{
		public Indicators.VolumeProfileTest VolumeProfileTest()
		{
			return indicator.VolumeProfileTest(Input);
		}

		public Indicators.VolumeProfileTest VolumeProfileTest(ISeries<double> input )
		{
			return indicator.VolumeProfileTest(input);
		}
	}
}

namespace NinjaTrader.NinjaScript.Strategies
{
	public partial class Strategy : NinjaTrader.Gui.NinjaScript.StrategyRenderBase
	{
		public Indicators.VolumeProfileTest VolumeProfileTest()
		{
			return indicator.VolumeProfileTest(Input);
		}

		public Indicators.VolumeProfileTest VolumeProfileTest(ISeries<double> input )
		{
			return indicator.VolumeProfileTest(input);
		}
	}
}

#endregion
